*TITLE	'MODEL II BASIC ENHANCEMENTS'
;
;	Created: 08/24/82	sjp/mss
;
;	HOOKS TO BASIC ROUTINES
;
	ORG	2800H		;BASIC ENTRY
	JP	ENTRY		;NEW ENTRY
	ORG	68F4H		;AUTO LOADER
	LD	HL,(FNAME)	;HL => NAME
;
	ORG	6098H		;SYSTEM ROUTINE
	CALL	SYSTEM		;SYSTEM DRIVER
	ORG	67BDH		;OPEN ROUTINE
	NOP			;NO CLOSE
;
	ORG	3010H		;READY ROUTINE
	CALL	SHORT		;SHORTHAND
	ORG	3030H		;READY ROUTINE
	CALL	NEWE		;NEW ENCODER
;
	ORG	331FH		;INSIDE LINE DECODER
	JP	LABEL		;OUR ROUTINE
	ORG	67F3H		;NAME ROUTINE
	JP	BASX25		;OUR ROUTINE
;
	ORG	301BH		;READY ROUTINE
	CALL	LINE
	ORG	34CDH		;AUTO INC
	CALL	LINE
	ORG	39C9H		;& CONVERSION
	JP	NZ,LINE
	ORG	3E0DH		;RENUM INC
	CALL	LINE
	ORG	400BH		;RENUM REFRENCE
	CALL	LINE
	ORG	5FD7H		;F1 KEY EDIT
	CALL	LINE
;
*TITLE	'SYSTEM ROUTINE PATCHES'
;
	ORG	6901H		;END EXISTING CODE
;
;	MISCELLANEOUS EQUATES
;
SVC	EQU	8		;EXECUTE SVC
ETX	EQU	3		;ASCII ETX
RETCMD	EQU	38		;EXECUTE DOS CMD
FILES$	EQU	2B57H		;FILE AREA TABLE
;
;	PATCH 'SYSTEM' ROUTINE
;
SYSTEM	EX	DE,HL		;DE => CMD
	LD	A,B		;A = LEN
	LD	HL,(FILES$)	;HL => FILES
	LD	BC,66		;OFFSET TO BUFF
	ADD	HL,BC		;HL => BUFFERS
	LD	C,A		;BC = COUNT
	EX	DE,HL		;DE => BUFFERS
	PUSH	DE		;SAVE => CMD
	LDIR			;MOVE!
	LD	A,ETX		;END TEXT
	LD	(DE),A		;TO CMD
	POP	HL		;HL => CMD
	LD	A,RETCMD	;DO IT!
	RST	SVC
	RET
;
*TITLE	'IMMEDIATE MODE COMMANDS'
;
;	ASCII CHAR EQUIVALENCES
;
BK	EQU	8		;ASCII BKSP
HT	EQU	9		;ASCII HT
ETB	EQU	23		;ASCII ETB
;
;	BASIC RST' ROUTINES
;
GETCHR	EQU	28H		;RST TO FETCH CHAR
CPHLDE	EQU	30H		;RST TO CP HL & DE
;
;	MISCELLANEOUS ROUTINES
;
INKEY	EQU	575EH		;WAIT FOR KEYBOARD
DSP	EQU	57EEH		;OUTPUT BYTE DISPLAY
BASX5	EQU	2FC2H		;BASIC RE-ENTRY
BASX3	EQU	30D8H		;FIND BASIC LINE
BASX2	EQU	5F4BH		;INSIDE KEYIN ROUTINE
BASX4	EQU	5354H		;EDIT ROUTINE
BASX14	EQU	3D4CH		;OUTPUT TEXT LINE
BASX13	EQU	3D55H		;EXPAND BASIC TEXT
BASX11	EQU	4A31H		;OUTPUT LINE NUMBER
BASX12	EQU	56B6H		;OUTPUT CHAR W/TAB
BASX15	EQU	57BAH		;OUTPUT C/R
;
;	MISCELLANEOUS VARIABLES
;
PGMBEG	EQU	2B4FH		;START BASIC TEXT
VARX1$	EQU	2B85H		;INPUT FLAG
INPBUF	EQU	2BADH		;INPUT BUFFER
CURNUM	EQU	2CF7H		;CURRENT LINE NUM
;
*EJECT
;	FETCH IMMEDIATE COMMAND
;
;
SHORT	XOR	A		;ZERO
	LD	(VARX1$),A	;FLAG
	CALL	INKEY		;INPUT BYTE
;
	LD	DE,(CURNUM)	;CURRENT LINE NUMBER
	CP	1FH		;NEXT LINE?
	JR	Z,SHORT1	;IF YES
	CP	1EH		;PREVIOUS LINE?
	JR	Z,SHORT1	;IF YES
	CP	'.'             ;CUR LINE?
	JR	Z,SHORT1	;IF YES
	CP	','             ;EDIT?
	JR	Z,SHORT1	;IF YES
;
	LD	DE,-1		;END TEXT
	CP	1DH		;END?
	JR	Z,SHORT1	;GO!
	CP	'/'             ;END?
	JR	Z,SHORT1	;GO!
;
	PUSH	AF		;CHAR TO STACK
	LD	HL,(PGMBEG)	;START BASIC TEXT
	CP	1CH		;TOP LINE?
	JR	Z,SHORT2	;IF YES
	CP	';'             ;TOP LINE?
	JR	Z,SHORT2	;IF YES
	POP	AF		;GET CHAR
	JP	BASX2		;INSIDE KEYIN
;
;	LOCATE LINE ADDRESS
;
SHORT1	PUSH	AF		;SAVE CMD BYTE
	CALL	BASX3		;FIND LINE
	POP	DE		;D = CMD BYTE
	LD	A,D		;GET CMD
	PUSH	AF		;SAVE CMD
	JR	NC,SHORT7	;NO FOUND
	CP	'.'             ;DSP CUR LINE?
	JR	Z,SHORT5	;IF YES
	CP	','             ;EDIT CUR LINE?
	JR	Z,SHORT5	;IF YES
	CP	1FH		;DSP NEXT LINE?
	JR	NZ,SHORT7	;IF NOT
;
	LD	A,(HL)		;LSB LINE ADD
	INC	HL
	OR	(HL)		;MSB LINE ADD
	DEC	HL		;CORRECT
	JR	NZ,SHORT2	;HAVE NEXT LINE
	JR	SHORT5		;CURRENT LINE
;
SHORT7	LD	HL,(PGMBEG)	;START BASIC TEXT
	OR	A		;CLR CRY
	SBC	HL,BC		;FIRST LINE?
	JR	Z,SHORT5	;IF YES
	ADD	HL,BC		;CORRECT
	LD	E,C
	LD	D,B		;DE = CURLIN
;
SHORT8	LD	C,L
	LD	B,H		;BC = CURLIN
	LD	A,(HL)		;LSB LINE ADD
	INC	HL
	LD	H,(HL)		;MSB LINE ADD
	LD	L,A		;HL => LINE
	RST	CPHLDE		;NXTLIN FOUND?
	JR	NZ,SHORT8	;TIL FOUND
;
SHORT5	LD	L,C
	LD	H,B		;HL = CURLIN
;
;	EXECUTE IMMEDIATE CMD
;
SHORT2	POP	BC		;GET CMD BYTE
;
	POP	AF		;IGNORE CALLER
	LD	A,(HL)		;LSB LINE ADD
	INC	HL
	OR	(HL)		;MSB LINE ADD
	INC	HL
	JR	NZ,SHORT4	;HAVE LINE
	CALL	BASX15		;OUTPUT C/R
	JP	BASX5		;RE-ENTER BASIC
;
SHORT4	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE = LINE NUM
	INC	HL		;HL => LINE TEXT
	LD	A,','           ;EDIT
	CP	B		;EDIT?
	JP	Z,BASX4 	;EDIT ROUTINE
;
	PUSH	DE		;SAVE LINE NUM
	LD	A,BK		;BEG OF LINE
	CALL	DSP		;DISP CTL
	LD	A,ETB		;ERACE TO EOL
	CALL	DSP		;DISP CTL
	POP	DE		;GET LINE NUM
	LD	(CURNUM),DE	;ADJ LINE NUM
	CALL	LIST		;LIST LINE
	JP	BASX5		;BASIC RE-ENTRY
;
*TITLE	'ABBREVIATED TOKEN HANDLER'
;
;	BASIC VERBS AND KEYWORDS
;
TK$INP	EQU	134		;INPUT
TK$GTO	EQU	138		;GOTO
TK$RUN	EQU	139		;RUN
TK$REM	EQU	144		;REM
TK$EDI	EQU	156		;EDIT
TK$LOD	EQU	165		;LOAD
TK$NAM	EQU	167		;NAME
TK$KIL	EQU	168		;KILL
TK$SAV	EQU	171		;SAVE
TK$SYS	EQU	172		;SYSTEM
TK$LST	EQU	177		;LIST
TK$DEL	EQU	179		;DELETE
TK$AUT	EQU	180		;AUTO
TK$EQU	EQU	215		;=
;
;	BASIC RST' ROUTINES
;
CPHLSP	EQU	20H		;CP (HL) & (SP)
GETCHR	EQU	28H		;FETCH NEXT CHAR
;
;	MISCELLANEOUS ROUTINES
;
ULERR	EQU	3376H		;UNDEFINED LINE
BASXX	EQU	3313H		;FETCH LINE NUMBER
BASX3	EQU	30D8H		;FIND BASIC LINE
BASX9	EQU	3DB7H		;INSIDE DELETE
BASX10	EQU	303BH		;INSERT TEXT LINE
BASX20	EQU	30A4H		;UPDATE LINE POINTERS
BASX21	EQU	30F5H		;ENCODE LINE
;
;	MISCELLANEOUS VARIABLES
;
INPBUF	EQU	2BADH		;INPUT BUFFER LOC
;
*EJECT
;	ALTERNATE LINE ENCODER
;
NEWE	CALL	BASX21		;ENCODE LINE
	PUSH	HL		;SAVE REGISTERS
	PUSH	DE
	PUSH	BC
	PUSH	AF		;SAVE REG
	LD	B,0		;FLAG 1ST STMNT
;
NEW0	RST	GETCHR		;FETCH NEXT
	JR	Z,NEWA		;END STMNT
	CP	TK$REM		;REMARK?
	JR	Z,NEW9		;IF YES
;
;	CHECK FOR SHORTHAND
;
	PUSH	HL		;SAVE CODE STRING
	LD	DE,TABLE	;DE => SHORTHAND
	LD	C,A		;C = CHAR
NEW1	LD	A,(DE)		;GET ENTRY
	INC	DE		;DE => TOKEN
	OR	A		;END TABLE?
	JR	Z,NEW7		;SKIP
	CP	C		;MATCH?
	JR	Z,NEW2		;IF YES
	INC	DE		;NEXT
	JR	NEW1		;IF YES
;
;	CHECK VAR ASSIGNMENT
;
NEW2	CALL	CHRGET		;GET NEXT
	JR	Z,NEW3		;END STMNT
	CP	TK$EQU		;ASSIGNMENT?
	JR	Z,NEW7		;IF YES
	JR	NEW2		;SKIP
;
;	HANDLE SPECIAL CASES
;
NEW3	POP	HL
	PUSH	HL		;HL => SHORTHAND
	LD	A,C		;GET CHAR
	CP	'L'             ;LIST?
	JR	NZ,NEW4 	;IF NOT
	RST	GETCHR		;FETCH NEXT
	CP	'"'             ;LOAD?
	JR	NZ,NEW5 	;IF NOT
	LD	A,TK$LOD	;LOAD TOKEN
	JR	NEW6		;SKIP
;
NEW4	CP	'D'             ;DELETE?
	JR	NZ,NEW5 	;IF NOT
	INC	B
	DEC	B		;1ST STMNT?
	JR	NZ,NEW5 	;IF NOT
	POP	BC		;BUMP STACK
	POP	AF		;GET FLAG
	PUSH	AF		;SAVE FLAG
	PUSH	BC		;RESTORE STACK
	JR	C,NEW5		;IF LINE
	RST	GETCHR		;FETCH NEXT
	CP	'I'             ;DI?
	JR	Z,SHRT16	;INSERT ROUTINE
	SUB	'U'             ;DU?
	JR	Z,SHRT16	;DUPLICATE ROUTINE
;
;	PLACE SHORTHAND TOKEN
;
NEW5	LD	A,(DE)		;GET TOKEN
NEW6	POP	HL
	PUSH	HL		;HL => SHORTHAND
	LD	(HL),A		;SET TOKEN
;
;	LOCATE END-OF-STMNT
;
NEW7	POP	HL		;HL => CODE STRING
NEW8	CALL	CHRGET		;FETCH CHAR
	JR	NZ,NEW8 	;NO END STMNT
NEWA	LD	B,A		;FLAG NOT 1ST
	OR	A		;EOL?
	JR	NZ,NEW0 	;IF NOT
;
;	RESTORE REG & EXIT
;
NEW9	POP	AF		;RESTORE REG
	POP	BC
	POP	DE
	POP	HL
	RET
;
;	GET NEXT CHAR ROUTINE
;
CHRGET	RST	GETCHR		;GET NEXT CHAR
	RET	Z		;END STMNT
	CP	'"'             ;LITERAL?
	RET	NZ		;IF NOT
CHRGT1	RST	GETCHR		;GET NEXT CHAR
	OR	A		;EOL?
	RET	Z		;IF YES
	CP	'"'             ;END LITERAL?
	JR	NZ,CHRGT1	;IF NOT
	OR	A		;NZ STATUS
	RET
;
;	DELETE/INSERT COMMANDS
;
SHRT16	LD	(SCMD),A	;SAVE CMD
	RST	GETCHR		;GET NEXT CHAR
	CALL	BASXX		;GET LINE NUM
	LD	B,D
	LD	C,E		;BC = LINE NUM
	RST	CPHLSP
	DEFB	','             ;SYNTAX
	CALL	BASXX		;GET LINE NUM
;
	PUSH	DE		;SAVE 2ND LINE NUM
	LD	D,B
	LD	E,C		;DE = 1ST LINE NUM
	CALL	BASX3		;FIND BASIC LINE
	JP	NC,ULERR	;UL ERROR
	LD	DE,INPBUF-2	;INPUT BUFFER LOC
	PUSH	DE		;SAVE INPBUF-2
	PUSH	BC		;SAVE 1ST LINE
	LD	H,B
	LD	L,C		;HL => 1ST LINE
	LD	BC,4
	ADD	HL,BC		;HL => 1ST STRING
;
SHRT19	LD	A,(HL)		;MOVE LINE
	LD	(DE),A
	INC	HL		;NEXT
	INC	DE		;NEXT
	INC	BC		;NEXT
	OR	A		;EOL?
	JR	NZ,SHRT19	;TIL EOL
	LD	D,B
	LD	E,C		;DE = LEN LINE
	POP	BC		;GET 1ST LINE
	PUSH	DE		;SAVE LEN BUFF
SCMD	EQU	$+1
	LD	A,0		;DELETE FLAG
	OR	A		;DELETE?
	JR	Z,SHRT20	;IF NOT
	CALL	BASX9		;DELETE ROUTINE
	CALL	BASX20		;UPDATE LINE POINTERS
;
SHRT20	POP	BC		;GET LEN CODE STRING
	POP	HL		;GET INPBUF-2 (CODE STR)
	DEC	HL		;CORRECT
	POP	DE		;GET 2ND LINE NUMBER
	JP	BASX10		;INSERT LINE
;
*EJECT
;	TABLE OF SHORTHAND CMDS
;
TABLE	DEFB	'A'
	DEFB	TK$AUT
	DEFB	'D'
	DEFB	TK$DEL
	DEFB	'E'
	DEFB	TK$EDI
	DEFB	'G'
	DEFB	TK$GTO
	DEFB	'I'
	DEFB	TK$INP
	DEFB	'K'
	DEFB	TK$KIL
	DEFB	'L'
	DEFB	TK$LST
	DEFB	'R'
	DEFB	TK$RUN
	DEFB	'S'
	DEFB	TK$SAV
	DEFB	'N'
	DEFB	TK$NAM
	DEFB	'!'
	DEFB	TK$SYS
	DEFB	0
;
*TITLE	'LABEL ADDRESSING MODULE'
;
TK$NAM	EQU	167		;NAME TOKEN
;
;	MISCELLANEOUS ROUTINES
;
GETCHR	EQU	28H		;GET NEXT CHAR
CPHLDE	EQU	30H		;RST TO CP HL & DE
BASX22	EQU	59E7H		;CHECK FOR A-Z
BASX25	EQU	33A2H		;SKIP STATEMENT
BASX26	EQU	30BCH		;CONVERT LINE RANGE
SNERR	EQU	2EF5H		;SYNTAX ERROR
ULERR	EQU	3376H		;UNDEF LINE ERROR
;
;	MISCELLANEOUS VARIABLES
;
PGMBEG	EQU	2B4FH		;START PROGRAM TEXT
;
*EJECT
;	CHECK FOR LABEL REFRENCE
;
LABEL	LD	DE,0		;INIT RESULT
	RST	GETCHR		;GETCHR
	RET	Z		;END STMNT
	JR	NC,LABL4	;CHECK FOR LABEL
;
;	CONVERT ASCII LINE NUMBER
;
LABL2	PUSH	HL		;SAVE CODE STRING
	PUSH	AF		;SAVE DIGIT
	LD	HL,6552 	;65530/10
	RST	CPHLDE		;VALID?
	JR	C,LABLB 	;IF NOT
	LD	H,D
	LD	L,E		;HL = RESULT
	ADD	HL,HL		;* 2
	ADD	HL,HL		;* 4
	ADD	HL,DE		;* 5
	ADD	HL,HL		;* 10
	POP	AF		;GET DIGIT
	SUB	'0'             ;KILL ASCII
	LD	E,A
	LD	D,0		;DE = DIGIT
	ADD	HL,DE		;HL = RESULT
	EX	DE,HL		;DE = RESULT
	POP	HL		;GET CODE STRING
;
LABL3	RST	GETCHR		;GETCHR
	JR	C,LABL2 	;IF NUMERIC
	RET
;
;	OVERFLOW EXIT'S HERE
;
LABLB	POP	AF		;RESTORE
	POP	HL
	RET
;
;	FORCED NUMBER REFRENCE
;
LINE	DEC	HL		;BKSP
	LD	DE,0		;INIT RESULT
	JR	LABL3		;GO
;
*EJECT
;	SEARCH FOR OPTIONAL LABEL
;
LABL4	CALL	BASX22		;CHECK FOR A-Z
	RET	C		;NOT ALPHA
	EX	DE,HL		;DE => LABEL
	LD	HL,(PGMBEG)	;HL => START PROGRAM
	DEC	DE		;BKSP LABEL
;
	PUSH	BC		;SAVE
LABL5	LD	C,(HL)
	INC	HL
	LD	B,(HL)		;BC => NEXT LINE
	INC	HL		;HL => LINE NUMBER
	LD	A,B
	OR	C
	JP	Z,ULERR 	;UNDEFINED LABEL
;
	PUSH	HL		;SAVE => LINE NUMBER
	INC	HL		;HL => START TEXT-1
	RST	GETCHR		;GET NEXT CHAR
	CP	TK$NAM		;NAME TOKEN?
	JR	NZ,LABL7	;IF NOT - NEXT LINE
;
	PUSH	DE		;SAVE => LABEL
LABLA	RST	GETCHR		;FETCH LABEL
	JR	Z,LABL8 	;END STMNT
	CCF
	CALL	C,BASX22	;A-Z?
	JR	C,LABL8 	;IF NOT 0-9 OR A-Z
	EX	DE,HL		;HL => LABEL
	RST	GETCHR		;GET NEXT CHAR
	EX	DE,HL		;HL => LINE
	CP	(HL)		;MATCH?
	JR	Z,LABLA 	;IF YES
;
LABL6	POP	DE		;GET => LABEL
LABL7	POP	HL		;GET => LINE NUMBER
	LD	H,B
	LD	L,C		;HL => NEXT LINE
	JP	LABL5		;TIL EOT
;
LABL8	EX	DE,HL		;HL => LABEL
	RST	GETCHR		;GET NEXT CHAR
	EX	DE,HL		;HL => LINE
	JR	Z,LABL9 	;END STMNT
	EX	DE,HL		;HL => LABEL
	CCF
	CALL	C,BASX22	;A-Z?
	EX	DE,HL		;HL => LINE
	JR	NC,LABL6	;IF 0-9 OR A-Z
;
LABL9	POP	HL		;GET => LABEL
	POP	HL		;GET => LINE NUMBER
	PUSH	DE		;SAVE => END LABEL
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE = LINE NUMBER
	POP	HL		;HL => CODE STRING
	POP	BC		;RESTORE
	RET
;
*EJECT
;	SUBROUTINE TO LIST SINGLE LINE
;
;	ENT	DE =	LINE NUMBER
;		HL =>	LINE TEXT
;
LIST	PUSH	HL		;SAVE LINE TEXT
	EX	DE,HL		;HL = LINE NUM
	CALL	BASX11		;OUTPUT LINE NUM
	POP	HL		;GET LINE TEXT
	LD	A,(HL)		;GET CHAR
	CP	HT		;TAB?
	JR	Z,$+7		;SKIP
	LD	A,' '           ;BLANK
	CALL	BASX12		;OUTPUT BLANK
	CALL	BASX13		;EXPAND CODE STRING
	LD	HL,INPBUF	;HL => INPUT BUFFER
	CALL	BASX14		;OUTPUT LINE
	JP	BASX15		;OUTPUT C/R
;
ENDRES	DEFW	0		;END RESIDENT CODE
;
*TITLE	'COLD INITIALIZATION'
;
;	MISCELLANEOUS ROUTINES
;
CPHLSP	EQU	20H		;CP (HL) & (SP)
GETCHR	EQU	28H		;GET NEXT CHAR
CPHLDE	EQU	30H		;CP HL & DE
;
BSTART	EQU	2800H		;BASIC ENTRY
DSPLIN$ EQU	5B59H		;LINE DISPLAY
BREAK$	EQU	6069H		;BREAK KEY VECTOR
LABEL1$ EQU	2CBCH		;STRING WORKSPACE 33 BYTES
LABEL2$ EQU	2D26H		;?
LABEL3$ EQU	2EF5H		;?SN ERROR
LABEL4$ EQU	39C7H		;DECBIN CONV
LABEL5$ EQU	330EH		;?FC ERROR
LABEL6$ EQU	5837H		;?OM ERROR
LABEL7$ EQU	2B57H		;=> FILE TABLE
LABEL8$ EQU	5829H		;INIT POINTERS
LABEL9$ EQU	4A31H		;BINDEC CONV
LABELB$ EQU	57BAH		;NEW ROUTINE
LABELC$ EQU	2E7FH		;WARM ENTRY
LABELD$ EQU	68EBH		;LOAD PROGRAM
;
RST20$	EQU	68D5H		;RST CODE
RST28$	EQU	68DDH		;RST CODE
RST30$	EQU	68E5H		;RST CODE
;
;	MISCELLANEOUS VARIABLES
;
VAR1$	EQU	2CEAH		;=> CMD LINE
VAR2$	EQU	2CB8H		;=> HIMEM
VAR3$	EQU	2B4BH		;=> STACK
VAR4$	EQU	2CF3H		;=> STRINGS
VAR5$	EQU	2B4DH		;CURRENT LINE
VAR6$	EQU	2B48H		;LAST ERROR CODE
VAR7$	EQU	2CAFH		;?
VAR8$	EQU	2B41H		;ERR STORAGE
VAR9$	EQU	2B43H		;PRINTER POSITION
VAR10$	EQU	2CBAH		;NEXT AVAIL STRING
VAR11$	EQU	2D8EH		;?
VAR12$	EQU	2B77H		;FILES STORAGE
VAR13$	EQU	2B55H		;START FILE AREAS
VAR14$	EQU	2B4FH		;START VARIABLES
VAR15$	EQU	2FB8H		;INSIDE READY, CALL DSPLIN
;
;	LOCAL EQUIVALENCES
;
SETBRK	EQU	3		;SVC BREAK KEY
HLDKEY	EQU	29		;PROCESS HOLD
LF	EQU	10		;ASCII LF
CR	EQU	13		;ASCII CR
SVC	EQU	08H		;EXECUTE SVC
JP	EQU	0C3H		;JP INST
;
*EJECT
;	INITIALIZATION CODE ENTRY
;
ENTRY	LD	(VAR1$),HL	;SAVE CMD LINE
	LD	(VAR2$),DE	;SAVE HI-MEM
;
;	SET-UP RST'S FOR BASIC USE
;
	LD	A,JP		;JP INST
	LD	HL,RST20$	;RST CODE
	LD	(20H+1),HL	;TO RST
	LD	(20H),A 	;TO RST
	LD	HL,RST28$	;RST CODE
	LD	(28H+1),HL	;TO RST
	LD	(28H),A 	;TO RST
	LD	HL,RST30$	;RST CODE
	LD	(30H+1),HL	;TO RST
	LD	(30H),A 	;TO RST
;
;	GENERAL BASIC INITIALIZATION
;
	LD	SP,ENDPGM+100	;TEMP STACK
	LD	(VAR3$),SP	;STACK LOC
	LD	(VAR4$),SP	;START STRINGS
;
	LD	HL,BREAK$	;BREAK VECTOR
	LD	A,SETBRK	;SET BREAK
	RST	SVC		;DO IT!
	LD	B,0		;TURN OFF HOLD
	LD	A,HLDKEY	;HOLD KEY
	RST	SVC		;DO IT!
;
	LD	HL,-2		;EXIT DOS FLAG
	LD	(VAR5$),HL	;CURRENT LINE
	LD	HL,0		;ZERO
	LD	(VAR9$),HL	;PRT POS,DEVICE
	LD	HL,LABEL1$	;STRING WORKSPACE (33 BYTES)
	LD	(VAR10$),HL	;INIT STRINGS AS EMPTY
	LD	HL,LABEL2$	;NEXT AVAIL STRING
	LD	(VAR11$),HL	;?
	XOR	A		;ZERO
	LD	(VAR6$),A	;LAST ERROR CODE
	LD	(VAR7$),A	;?
	LD	(VAR8$),A	;$ERR STORAGE
	LD	A,0		;DEFAULT
	LD	(VAR12$),A	;DEFAULT FILES
;
;	FIND END OF CMDLINE
;
	LD	HL,(VAR1$)	;HL => CMD LINE
ICMD1	LD	A,(HL)		;GET CHAR
	CP	LF		;L/F?
	JR	Z,ICMD2 	;DONE
	CP	CR		;C/R?
	JR	Z,ICMD2 	;DONE
	INC	HL		;NEXT
	JR	ICMD1		;TIL DONE
ICMD2	LD	(HL),0		;END TEXT
;
*EJECT
;	CHECK FOR PROGRAM NAME
;
	LD	HL,(VAR1$)	;HL => CMD LINE
	DEC	HL		;BKSP
	RST	GETCHR		;GET NEXT CHAR
	OR	A		;END LINE?
	JP	Z,ICMD8 	;IF END OF LINE
	CP	'-'             ;SWITCH?
	JR	Z,ICMD4 	;IF SWITCH
	DEC	HL		;BKSP CHAR
	LD	(HL),'"'        ;LITERAL
	LD	(FNAME),HL	;SAVE START NAME
	INC	HL		;INC
;
;	LOCATE END OF NAME
;
ICMD3	CP	'-'             ;END NAME?
	JR	Z,ICMD4 	;IF YES
	RST	GETCHR		;GET NEXT CHAR
	OR	A		;END NAME?
	JR	NZ,ICMD3	;TIL END
	JR	ICMD8		;SKIP
;
ICMD4	LD	(HL),0		;FORCE EOT
	RST	GETCHR		;GET NEXT CHAR
;
;	LOCATE OPTIONAL SWITCH
;
ICMD7	RES	5,A		;IGNORE CASE
	CP	'M'             ;MEMORY?
	PUSH	AF		;SAVE SWITCH
	JP	Z,ICMD5 	;IF MEMORY
	CP	'F'             ;FILES?
	JP	NZ,LABEL3$	;?SN ERROR
;
ICMD5	RST	GETCHR		;GET NEXT CHAR
	RST	CPHLSP		;SYNTAX CHECK
	DEFB	':'
	CALL	LABEL4$ 	;CONV TO BINARY
	POP	AF		;GET STAT
	JR	Z,ICMD6 	;IF MEMORY
;
;	HANDLE FILES SWITCH
;
	LD	A,D		;MSB FILES
	OR	A		;> 255?
	JP	NZ,LABEL5$	;?FC ERROR
	LD	A,E		;LSB FILES
	CP	15+1		;VALID?
	JP	NC,LABEL5$	;?FC ERROR
	LD	(VAR12$),A	;SAVE FILES
	JR	ICMD9		;SKIP
;
;	HANDLE MEMORY SWITCH
;
ICMD6	LD	(VAR2$),DE	;SET HIMEM
;
;	ANY MORE SWITCHES?
;
ICMD9	DEC	HL		;BKSP
	RST	GETCHR		;GET NEXT CHAR
	JR	Z,ICMD8 	;END LINE
	RST	CPHLSP		;SYNTAX CHECK
	DEFB	'-'
	JR	ICMD7		;IF MORE
;
*EJECT
;	CHECK FOR VALID MEMORY
;
ICMD8	DEC	HL		;BKSP
	LD	HL,(VAR2$)	;GET HI-MEM
	DEC	HL		;LESS 1
	LD	(VAR2$),HL	;SAVE HI-MEM
	LD	DE,-99		;MIN AMOUNT
	ADD	HL,DE		;100 BYTES?
	JP	NC,LABEL6$	;?OM ERROR
	DEC	HL		;HL => END-100
;
;	INITIALIZE FILE AREAS
;
	PUSH	HL		;SAVE END-100
	LD	HL,ENDRES	;START FILE AREAS
	LD	(VAR13$),HL	;SET START FILES
	LD	DE,LABEL7$	;DE => FILE TABLE
	LD	A,(VAR12$)	;FILE COUNT
	INC	A		;+ SYSTEM
	LD	BC,512+60+6	;BUFF SIZE
;
IFILE1	EX	DE,HL		;HL => TABLE
	LD	(HL),E		;LSB AREA
	INC	HL		;NEXT
	LD	(HL),D		;MSB AREA
	INC	HL		;NEXT
	EX	DE,HL		;HL => AREA
	ADD	HL,BC		;HL => NEXT AREA
	DEC	A		;DONE?
	JR	NZ,IFILE1	;TIL DONE
	INC	HL		;BYTE AFTER FILES
	LD	(VAR14$),HL	;START VARIABLES
;
;	CHECK & OUTPUT MEMORY SIZE
;
	EX	(SP),HL 	;HL => END-100
	LD	DE,ENDPGM+100	;END PGM
	RST	CPHLDE		;OVERFLOW?
	JP	C,LABEL6$	;?OM ERROR
	POP	DE		;DE => FREE MEM
	LD	SP,HL		;SP END-100
	LD	(VAR3$),HL	;STACK
	LD	(VAR4$),HL	;STACK
	EX	DE,HL		;DE => END-100
	CALL	LABEL8$ 	;INIT POINTERS
	LD	A,E
	SUB	L
	LD	L,A		;HAVE LSB SIZE
	LD	A,D
	SBC	A,H
	LD	H,A		;HL = FREE SIZE
	LD	BC,-16		;16 BYTES OVERHEAD
	ADD	HL,BC		;HL = MEM
	PUSH	HL		;SAVE SIZE
	LD	HL,MES1 	;'PROGRAM TITLE'
	CALL	DSPLIN$ 	;OUTPUT
	POP	HL		;GET SIZE
	CALL	LABEL9$ 	;CONV TO DECIMAL
	LD	HL,MES2 	;'BYTES FREE'
	CALL	DSPLIN$ 	;OUTPUT
;
;	OUTPUT FILES AND EXIT
;
	LD	A,(VAR12$)	;FILES
	LD	L,A
	LD	H,0		;HL = FILES
	CALL	LABEL9$ 	;CONV TO DECIMAL
	LD	HL,MES3 	;'FILES'
	CALL	DSPLIN$ 	;OUTPUT
	LD	HL,DSPLIN$	;OUTPUT MESSAGE
	LD	(VAR15$),HL	;TO READY
	CALL	LABELB$ 	;NEW ROUTINE
	LD	HL,LABELC$	;WARM ENTRY
	LD	(BSTART+1),HL	;TO VECTOR
	JP	LABELD$ 	;EXEC PROGRAM!
;
;	NULL FILENAME POINTER
;
FNAME	DEFW	$+2		;=> FILENAME
	DEFB	0		;NULL!
;
*EJECT
;	MESSAGES AND TEXT STRINGS
;
MES1	DEFM	'TRS-80 Model II BASIC-80 Rev. 1.2'
	DEFB	CR
	DEFM	'Copyright 1979, 1980 by Tandy Corp. '
	DEFM	'Licensed from Microsoft'
	DEFB	CR
	DEFM	'Enhancements (c)(p) Copyright 1982 by MicroPower, Inc.'
	DEFB	CR
	DEFM	'Created: 10-Jun-80'
	DEFB	CR
	DEFB	0
;
MES2	DEFM	' Bytes free, '
	DEFB	0
MES3	DEFM	' Files'
	DEFB	0
;
ENDPGM	EQU	$		;END INIT CODE
;
	aND	BSTAY