; dirfix/asm - kjw/bqsd - 08/82
;
	TITLE	'<Dos+ II - Directory Fixer - A.00>'
;
	ORG	2200H		;high overlay area
;
VERSION	EQU	10H		;1.0
MPASSW	EQU	42E0H		;password 'PASSWORD'
;
EVAL	EQU	83		;evaluate input line
VIDKEY	EQU	12		;video/keyboard
VDCHAR	EQU	8		;char to video
ERROR	EQU	39		;display error
SETBRK	EQU	3		;setup break processor
;
LOCDCT	EQU	032DH		;locate drive DCT
TOPMEM	EQU	0173H		;top memory
LOWMEM	EQU	0171H		;bottom memory
DATE$	EQU	0154H		;date storage
;
DCHECK	EQU	0		;check drive
DREAD	EQU	3		;read sector
SREAD	EQU	6		;read system sector
DWRITE	EQU	5		;write data sector
SWRITE	EQU	7		;write system sector
;
SVC	EQU	8		;execute SVC
DISKIO	EQU	10H		;disk I/O
OVLAY	EQU	18H		;overlay access
;
ERR8	EQU	8		;drive not ready
ERR47	EQU	47		;required not found
ERR48	EQU	48		;invalid param
ERR66	EQU	66		;no function exists
ERR82	EQU	82		;insufficient memory
ERR86	EQU	86		;program terminated
;
	PAGE
;
;	program entry point
;
ENTRY	LD	(STACK),SP	;save stack
;
	PUSH	HL		;save string pointer
	LD	HL,HELLO	;sign on message
	CALL	DISPLAY		;display it
;
	LD	HL,0		;turn off break processor
	LD	A,SETBRK	;SVC #
	RST	SVC		;do it
;
	POP	HL		;restore pointer
;
;	evaluate input line
;
SCAN	LD	IX,FIXBLK	;param block
	LD	A,EVAL		;SVC #
	RST	SVC		;evaluate user input
	JR	NZ,EXIT		;error, abort!
;
	LD	A,(IX)		;get input params
	AND	6		;source/dest fields?
	JR	Z,APARMS	;nope, prompt for params
;
	LD	DE,DCB		;point to DCB
	LD	A,(DE)		;get flag byte
	LD	B,ERR48		;required not found
	BIT	7,A		;device here?
	JR	Z,EXITB		;nope, abort
	AND	0FH		;get device number
	SUB	8		;must be 8-15
	LD	(DRIVE),A	;save the drive
	LD	A,ERR66		;no function exists
	JR	C,EXIT		;can't fix low devices
	JP	FIXIT		;go to it!
;
;
	PAGE
;
TERMIN	LD	A,ERR86		;program terminated
;
EXIT	AND	7FH		;make sure it comes back
	LD	B,A		;pass it here
EXITB	LD	A,ERROR		;SVC #
	RST	SVC		;display it
;
RETURN	LD	SP,0		;reset stack
STACK	EQU	$-2
	XOR	A		;return ZERO
	RET			;back to caller
;
;	prompt for parameters
;
APARMS	LD	HL,PMSG		;prompt message
	LD	BC,1<8+79	;disp len + key len
	LD	DE,STRING	;input buffer
	LD	A,VIDKEY	;SVC #
	RST	SVC		;display & keyboard
;
	JR	NZ,EXIT		;error, display it
	JR	C,TERMIN	;break, abort
;
	EX	DE,HL		;HL => input
	JR	SCAN		;evaluate input
;
	PAGE
;
;	prompt for diskette type to force data > DCT
;
FORCEIT	CALL	ASKSPECS	;get specs for drive
	JR	SPECBAK		;else resume
;
	PAGE
;
;	begin compiling disk
;
FIXIT	LD	C,0		;fetch drive
DRIVE	EQU	$-1
	CALL	LOCDCT		;load IY with DCT
	LD	A,(PROPAR)	;prompt for DCT?
	INC	A		;FF? (yes?)
	JR	Z,FORCEIT	;yes, stuff the DCT
;
	LD	A,DCHECK	;check drive
	RST	DISKIO		;check it out
	LD	A,ERR8		;drive not in system
	JR	NZ,EXIT		;can't check it
;
SPECBAK	LD	A,(IY+21)	;fetch grans / cyl
	LD	E,2		;set mask bit
	DEC	A		;less one
;
GPTSF	JR	Z,GOTGPT	;have the mask
	SLA	E		;move mask bit
	DEC	A		;less gran
	JR	GPTSF		;go again
GOTGPT	LD	A,E		;fetch mask
	LD	(TOPGRAN),A	;save top gran mask
;
;	check for sufficient memory
;
	LD	HL,(TOPMEM)	;fetch topmem
	LD	DE,(LOWMEM)	;fetch low memory
	XOR	A		;clear carry
	LD	C,A		;save here
	LD	A,ERR82		;insufficient memory
	SBC	HL,DE		;HL = free memory
	JR	C,EXIT		;memory pointer error!
	LD	B,(IY+18)	;fetch top sector
	INC	B		;even page
	SBC	HL,BC		;compute free buffer
	JR	C,EXIT		;can't fix it!
;
;	setup buffer pointers
;
;	check for lowmem less than program end
;
	LD	HL,ZZZZZ	;first free byte
	SBC	HL,DE		;compare 'em
	JR	C,MEMHAV	;DE = buffer start
	LD	DE,ZZZZZ	;else use program end
MEMHAV	INC	D		;bump to next page
	LD	E,0		;DE => free start page
	EX	DE,HL		;HL => first page
	LD	(GATBUFF),HL	;created GAT
	INC	H
	LD	(HITBUFF),HL	;created HIT
	INC	H
	LD	(DIRBUF),HL	;file records from disk
;
;	all OK, read in the directory
;
	CALL	RDDIR		;read it
	CALL	CLRGAT		;clear out the GAT
	CALL	CLRHIT		;clear out the HIT
;
	LD	HL,(DIRBUF)	;start of file records
	LD	(DIRPOS),HL	;save pointer
	LD	A,2		;relative sector
	LD	(DIRSEC),A	;save it
;
;	go to it!
;
CHKLP	LD	HL,0		;fetch current posit
DIRPOS	EQU	$-2
	BIT	4,(HL)		;active entry?
;
	PUSH	AF		;save 'em
	CALL	NZ,CHECKA	;checker A (GAT, names)
	POP	AF
;
	PUSH	AF		;save again
	CALL	NZ,CHECKB	;checker B
	POP	AF
;
	CALL	NZ,CHECKC	;checker C
;
	LD	HL,(DIRPOS)	;fetch position
	LD	BC,20H		;offset between
	ADD	HL,BC		;point to next file
	LD	(DIRPOS),HL	;resave position
;
	LD	A,L		;see if new sector
	OR	A		;zero?
	JR	NZ,CHKLP	;nope, continue
;
	LD	A,0		;get relative sector
DIRSEC	EQU	$-1
	INC	A		;bump it
	LD	(DIRSEC),A	;put it back
	CP	(IY+18)		;at top?
	JR	NZ,CHKLP	;nope, go more
	JP	COMPLETE	;finished, exit
;
	PAGE
;
;	$CHECKB - check HIT table
;
CHECKB	LD	HL,(DIRPOS)	;current record
	BIT	7,(HL)		;extended entry?
	RET	NZ		;yes, skip it
;
	PUSH	HL		;pass pointer to IX
	POP	IX		;get it
	LD	DE,(DIRBUF)	;start of records
	OR	A		;clear carry
	SBC	HL,DE		;compute DEC
	LD	A,H		;fetch rel sec
	OR	L		;or with rel byte
	LD	(DEC),A		;save entry code
;
	CALL	HASH		;compute HASH
	LD	(HIT),A		;save it
;
CHECKA1	LD	HL,(HITBUFF)	;HIT table
	LD	L,0		;get DEC
DEC	EQU	$-1
;
	LD	A,0		;fetch the HIT
HIT	EQU	$-1
	LD	(HL),A		;put it in
;
;	check for extended records
;
HITAA	LD	B,5		;go for 5 extents
;
HITA	LD	A,(IX+22)	;fetch extent element
	INC	A		;terminator?
	RET	Z		;yes, return
;
	INC	A		;extended record?
	JR	Z,HITB		;yes, fix that hit too
;
	INC	IX		;next extent
	INC	IX
	DJNZ	HITA		;go for 5 max
	RET			;corrupt! return
;
HITB	LD	A,(IX+23)	;get extension DEC
;
	PUSH	AF		;save un-adultered
	AND	0E0H		;relative byte
	LD	C,A		;pass here
	POP	AF		;fetch again
;
	LD	(DEC),A		;save it for link
	AND	1FH		;relative sector
	LD	B,A		;BC = directory offset
	LD	HL,(DIRBUF)	;start of records
	ADD	HL,BC		;point to it
	PUSH	HL
	POP	IX		;IX => extended record
;
	LD	HL,(HITBUFF)	;start of HIT table
	LD	A,(DEC)		;fetch DEC
	LD	L,A		;HL => hit this extent
	LD	A,(HIT)		;fetch file HIT
	LD	(HL),A		;put in table
	JP	HITAA		;continue
;
	PAGE
;
;	$CHECKA	- check GAT table and filenames
;
CHECKA	LD	HL,(DIRPOS)	;get position
	BIT	7,(HL)		;extended entry?
	RET	NZ		;yes, skip for now
;
	PUSH	HL		;pass to IX
	POP	IX
	LD	B,11		;check filename area
;
CK1A	LD	A,(IX+5)	;get name byte
	CALL	VALCHR		;valid character?
	CALL	Z,CK1B		;change to 5F if no
	LD	(IX+5),A	;put it back fixed
	INC	IX		;bump pointer
	DJNZ	CK1A		;finish the area
	JR	CK1C		;continue
;
CK1B	LD	A,(FILPAR)	;get file param
	INC	A		;filenames to be done?
	JP	NZ,CANTFIX	;if not, can't fix disk
;
	LD	A,5FH		;default character
	RET
;
CK1C	LD	IX,(DIRPOS)	;fetch position again
	PUSH	IX		;need in HL too
	POP	HL
	LD	DE,(DIRBUF)	;start of names
	OR	A		;compute DEC again
	SBC	HL,DE		;HL = DEC
	LD	A,H		;merge into single byte
	OR	L
	LD	(DEC),A		;save it
	LD	BC,0		;for file positioning
	LD	(RELSEC),BC	;save relative sector
;
CK1D	XOR	A		;set rel extent to 0
	LD	(CKEXT),A	;save it
;
CK1E	LD	A,(IX+22)	;fetch extent byte
	LD	D,A		;pass to D for track
	INC	A		;terminator?
	JP	Z,DONEWITH	;yes, done
	INC	A		;extension?
	JR	Z,NXFIL		;yes, get it
;
	LD	E,0		;start sector
	LD	C,(IY+20)	;sectors / gran
	LD	A,(IX+23)	;get extent
	AND	0E0H		;start grans bits
	SRL	A		;align to low bits
	SRL	A
	SRL	A
	SRL	A
	SRL	A
GNLP	OR	A		;have it?
	JR	Z,STGN		;yes, go!
	PUSH	AF		;save
	LD	A,E		;current sector
	ADD	A,C		;add sects this gran
	LD	E,A		;put it back
	POP	AF		;restore
	DEC	A		;less one
	JR	GNLP		;continue
;
STGN	LD	A,(IX+23)	;get extent
	AND	1FH		;number of grans
	INC	A		;adjust for real
	LD	C,A		;save here
	CALL	SHOPRT		;check it out
;
	JR	C,CANFIL	;error, terminate NOW
	INC	IX		;else next extent
	INC	IX
	LD	A,0		;see if all used
CKEXT	EQU	$-1
	INC	A		;bump it
	LD	(CKEXT),A	;put it back
	CP	5		;all used?
	JR	NZ,CK1E		;nope, continue
	DEC	IX		;no, kill last extent
	DEC	IX
;
;	no terminator field for file
;	kill last extent by placing a terminator
;
CANFIL	LD	(IX+22),0FFH	;set terminator in
	LD	(IX+23),0FFH
;
	LD	A,(FILPAR)	;fetch filespec fix
	INC	A		;filename fix specified?
	JP	NZ,CANTFIX	;nope, can't fix GAT
;
	JR	DONEWITH	;else done with this file
;
NXFIL	LD	A,(IX+23)	;fetch extent DEC
;
	PUSH	AF		;save it
	AND	1FH		;relative sector
	LD	B,A		;save here
	POP	AF		;fetch again
;
	AND	0E0H		;relative byte
	LD	C,A		;BC = displacement
	LD	HL,(DIRBUF)	;start of records
	ADD	HL,BC		;HL => record
;
;	make sure it correctly links
;
	BIT	4,(HL)		;active file?
	JR	Z,CANFIL	;nope, can last record
	BIT	7,(HL)		;valid extension?
	JR	Z,CANFIL	;nope, can last record
;
	LD	A,(IX+23)	;save the DEC
	PUSH	HL		;now can pass to IX
	POP	IX
	PUSH	AF		;save DEC
	LD	A,(DEC)		;fetch last one
	LD	(IX+1),A	;fix the backward link
	POP	AF		;restore this DEC
	LD	(DEC),A		;save it
	JP	CK1D		;continue with it
;
DONEWITH LD	IX,(DIRPOS)	;fetch file start
	LD	E,(IX+20)	;get end of file sector
	LD	D,(IX+21)
	LD	A,D		;is it 0?
	OR	E		;yes?
	JR	NZ,DWTH		;nope, continue
	LD	A,(IX+3)	;end of file byte
	OR	A		;this zero too?
	RET	Z		;yes, it's OK
;
DWTH	LD	HL,(RELSEC)	;get real sectors
	OR	A		;clear carry
	SBC	HL,DE		;test for end of file
	RET	NC		;not beyond limits
;
;	force end of allocation sector into EOF sector
;
	LD	HL,(RELSEC)	;get EOA sector
	LD	(IX+20),L	;stuff into EOF in DIR
	LD	(IX+21),H
;
	LD	A,(FILPAR)	;fetch file param
	INC	A		;files to be fixed?
	JP	NZ,CANTFIX	;nope, can't fix rest
	RET			;else done, return
;
;
SHOPRT	PUSH	HL		;save registers
	PUSH	DE
	PUSH	BC
;
PRTRLP	LD	B,(IY+20)	;sectors / gran
;
PRTLP	CALL	PRTHIS		;do this extent
	JR	C,PRTBAD	;error, go!
;
	CALL	NEXSEC		;advance the sector
	DJNZ	PRTLP		;finish this block
	DEC	C		;sectors / gran
	JR	NZ,PRTRLP	;finish it
	XOR	A
;
PRTBAD	POP	BC		;unstack and return
	POP	DE
	POP	HL
	RET
;
PRTHIS	PUSH	HL		;save pointer
	LD	HL,0		;get relative sector
RELSEC	EQU	$-2
	INC	HL		;bump it
	LD	(RELSEC),HL	;put it back
	POP	HL		;restore pointer
;
	LD	A,(IY+16)	;cylinder count
	CP	D		;past disk boundary?
	RET			;return with C flag
;
	PAGE
;
;	$CLRHIT	- clear out the HIT table
;
CLRHIT	LD	HL,(HITBUFF)	;start of buffer
	LD	D,H		;pass to DE
	LD	E,L
	INC	DE		;plus one
	LD	BC,0FFH		;length -1
	LD	(HL),0		;put in a zero
	LDIR			;put in all zeroes
	RET			;done, return
;
	PAGE
;
;	$CLRGAT	- clear out the GAT table
;
CLRGAT	LD	HL,(GATBUFF)	;start of table
	LD	D,H		;pass to DE
	LD	E,L
	INC	DE		;+1
	LD	BC,0FFH		;length -1
	LD	(HL),0FFH	;set all full
	LDIR			;in whole sector
;
	LD	B,(IY+21)	;grans / cylinder
	LD	C,8		;bits / byte
;
	XOR	A		;start bit pattern
NXNY	SCF			;set a bit
	RRA			;move it in
	DEC	C		;less byte
	DJNZ	NXNY		;do # grans / cyl
	INC	C		;check if done
NXNU	DEC	C
	JR	Z,NXNZ		;yes, go!
;
	OR	A		;clear carry
	RRA			;align bits
	JR	NXNU		;finish off C
;
NXNZ	LD	IX,(GATBUFF)	;start of GAT
	CPL			;reverse pattern
	LD	B,(IY+16)	;cylinder count
	LD	(GATNUL),A	;null byte
	BIT	5,(IY+5)	;rigid drive?
	JR	NZ,NXNT		;yes, no lockout
;
NXNV	LD	(IX),A		;put in a byte
	LD	(IX+60H),A	;lockout byte too
	INC	IX		;next track
	DJNZ	NXNV		;for track count
	JR	NXZZY		;done, finish it out
;
NXNT	LD	(IX),A		;put in GAT byte
	INC	IX		;next track
	DJNZ	NXNT		;for track count
;
NXZZY	LD	HL,DEFNAME	;default name for disk
	LD	DE,(GATBUFF)	;start of GAT
	LD	E,0CEH		;start of data
	LD	BC,19		;length of string
	LDIR			;move into GAT
;
;	fetch today's date
;
	LD	DE,DATE$	;point to date
;
	LD	A,(DE)		;get day in month
	LD	HL,(GATBUFF)	;start of GAT
	LD	L,0DBH		;where in sector
	CALL	ASCII2		;make it ascii
	INC	DE		;next
;
	LD	A,(DE)		;get month
	LD	L,0D8H		;where it goes
	CALL	ASCII2		;put in string
	INC	DE		;next
;
	LD	A,(DE)		;get year
	ADD	A,80		;add offset
	LD	L,0DEH		;where it goes
	JP	ASCII2		;make it ascii
;
NEXSEC	INC	E		;bump sector
	LD	A,(IY+22)	;fetch top sector
	SUB	E		;at end?
	RET	NZ		;nope, return
;
	LD	E,A		;reset to 0
	LD	A,D		;get track
	CP	(IY+16)		;at end of disk?
	RET	NC		;don't bump if yes
	INC	D		;else OK
	RET			;back
;
	PAGE
;
;	functions completed
;
COMPLETE LD	A,(GATPAR)	;fetch gat param
	INC	A		;fix GAT?
	CALL	Z,WRGAT		;yes, do it
;
	LD	A,(HITPAR)	;fetch hit param
	INC	A		;fix HIT?
	CALL	Z,WRHIT		;yes, write it
;
	LD	A,(FILPAR)	;repair files?
	INC	A		;yes?
	CALL	Z,WRDIR		;yes, write 'em out
;
;
	JP	RETURN		;exit the program
;
	PAGE
;
;	$WWRDIR	- write directory files to disk
;
WRDIR	LD	A,(DRIVE)	;fetch drive number
	LD	C,A		;pass it here
	LD	A,(IY+18)	;get number of sectors
	SUB	2		;less GAT & HIT
	LD	B,A		;for counter
	LD	E,2		;start sector
	LD	HL,(DIRBUF)	;start of data
;
WRDLP	PUSH	BC		;save counter
	LD	B,0		;for sector offset
	LD	A,SWRITE	;write system sector
	RST	DISKIO		;write it
	POP	BC
;
	JP	NZ,EXIT		;error, abort!
;
	INC	H		;bump buffer ptr
	INC	E		;bump sector
	DJNZ	WRDLP		;finish it off
	RET			;done, return
;
	PAGE
;
;	$WRGAT	- write GAT table to disk
;
WRGAT	LD	A,(DRIVE)	;get drive
	LD	C,A		;need it here
	LD	B,1		;one sector to write
	LD	E,0		;sector number
;
	LD	HL,(GATBUFF)	;start of GAT
	LD	L,0CBH		;GAT offset
	LD	A,VERSION	;version number
	LD	(HL),A		;put in gat
;
	INC	L		;next byte (CC)
	LD	A,(IY+16)	;cylinder count
	SUB	35		;less this
	LD	(HL),A		;put it in
;
	INC	L		;offset (CD)
	XOR	A		;load zero
	LD	(HL),A		;marker
;
	LD	L,0		;data source
	BIT	5,(IY+5)	;rigid drive?
	JP	Z,WRDLP		;nope, continue
	LD	A,(LOCPAR)	;get LAREDO flag
	INC	A		;yes?
	JP	NZ,WRDLP	;nope, write it back
;
;	laredo set, allocate track above directory
;
	LD	L,(IY+19)	;directory track
	INC	L		;next track up
	LD	A,(HL)		;get the byte
	CP	0		;compare to nil byte
GATNUL	EQU	$-1
	JR	NZ,SKPTHS	;if not the same, skip
	LD	(HL),0FFH	;nil track, set allocated
;
SKPTHS	LD	L,0		;start of data
	JP	WRDLP		;write it back
;
	PAGE
;
;	$WRHIT	- write HIT table to disk
;
WRHIT	LD	A,(DRIVE)	;fetch drive number
	LD	C,A		;need it here
	LD	B,1		;one sector to write
	LD	E,B		;sector number
	LD	HL,(HITBUFF)	;where data is
	JR	WRDLP		;write it out
;
	PAGE
;
;	$RDDIR	- read in the directory
;
RDDIR	LD	A,(DRIVE)	;fetch drive number
	LD	C,A		;pass here
	LD	B,(IY+18)	;number of sectors
	LD	E,0		;start sector
	LD	HL,(GATBUFF)	;start of data
;
RDDLP	PUSH	BC
	LD	B,0		;sector offset
	LD	A,SREAD		;read directory
	RST	DISKIO		;read the sector
	POP	BC
;
	JP	NZ,EXIT		;error, abort
;
	INC	H		;bump buffer
	INC	E		;bump sector
	DJNZ	RDDLP		;finish it off
	RET			;done, return
;
	PAGE
;
;	$HASH	- compute HASH code for file
;
HASH	PUSH	IX		;save pointer
	PUSH	BC		;need for compute
	LD	BC,0B00H	;# chars / start hash
;
HASHL	LD	A,(IX+5)	;fetch a byte
	INC	IX		;bump pointer
	XOR	C		;'hash' it
	RLCA
	LD	C,A		;save temp
	DJNZ	HASHL		;finish it
;
	OR	A		;see if 00
	JR	NZ,HASHOK	;nope, OK
	INC	A		;else make it one
;
HASHOK	POP	BC		;unstack & return
	POP	IX
	RET
;
	PAGE
;
;	$CHECKC	- check granules
;
CHECKC	LD	HL,(DIRPOS)	;get position
	BIT	7,(HL)		;extended entry?
	RET	NZ		;yes, skip for now
;
	PUSH	HL		;pass to IX
	POP	IX
;
CHECKC1	LD	B,5		;5 extents / entry
;
CHECKC2	LD	A,(IX+22)	;get an extent
	LD	D,A		;save track
;
	INC	A		;terminator?
	RET	Z		;yes, done
;
	INC	A		;extension?
	JP	Z,CHECKC3	;yes, get it
;
	LD	A,(IX+23)	;get extent
;
	PUSH	AF		;save original
	AND	1FH		;# grans
	INC	A		;make it real
	LD	C,A		;save here
	POP	AF		;get again
;
	LD	E,1		;bit mask
	RRCA			;align the bits
	RRCA
	RRCA
	RRCA
	RRCA
	AND	7		;want top 3 only
;
FINGLP	JR	Z,FINGHV	;have the gran
	SLA	E		;shift the bit over
	DEC	A		;continue
	JR	FINGLP
;
FINGHV	LD	HL,(GATBUFF)	;GAT table start
	LD	L,D		;D = track
;
RELGRNS	LD	A,(HL)		;get a byte
	OR	E		;set the bits
	LD	(HL),A		;put it back
;
	DEC	C		;more grans?
	JR	Z,RELGRDN	;nope, done
	LD	A,0		;else fetch top mask
TOPGRAN	EQU	$-1
	SLA	E		;move test bit over
	CP	E		;done with cylinder?
	JR	NZ,RELGRNS	;nope, continue
;
	INC	L		;next cylinder
	LD	E,1		;new mask
	JR	RELGRNS		;continue
;
RELGRDN	INC	IX		;next extent
	INC	IX
	DJNZ	CHECKC2		;finish it off
	RET			;done
;
CHECKC3	LD	A,(IX+23)	;get DEC for extension
;
	PUSH	AF		;save it
	AND	0E0H		;relative byte
	LD	C,A		;save here
	POP	AF		;get again
;
	AND	1FH		;relative sector
	LD	B,A		;BC = displacement
	LD	HL,(DIRBUF)	;start of records
	ADD	HL,BC		;HL => file record
	PUSH	HL		;pass to IX
	POP	IX
	JP	CHECKC1		;continue
;
;
CANTFIX	LD	HL,CANTFX	;message
	CALL	DISPLAY		;display it
	JP	TERMIN		;abort program
;
	PAGE
;
;	fetch and load drive specs
;
ASKSPECS LD	HL,SPECKS	;prompt for specs
	LD	BC,1<8+79	;display len + key len
	LD	DE,STRING	;key buffer
	LD	A,VIDKEY	;SVC #
	RST	SVC		;dislay, fetch keys
;
	JP	NZ,EXIT		;error!
	JP	C,TERMIN	;break, abort
	EX	DE,HL		;HL => input
;
;	evaluate input
;
;	check for number of cylinders
;
CKSPS	CALL	VALUE		;get number of cyls
	JP	NZ,EXIT		;abort!
	LD	(IY+16),C	;save cylinder count
;
;	check for density
;
	CALL	VALUE		;get density value
	JP	NZ,EXIT		;display error
	DEC	C		;single?
	JR	Z,SETSNG	;set single density
	DEC	C		;double?
	LD	A,ERR48		;invalid parameter
	JP	NZ,EXIT		;display error
SETDBL	SET	7,(IY+14)	;set double density
	JR	NXSPC
;
SETSNG	RES	7,(IY+14)	;set single density
;
;	check for number of sides
;
NXSPC	CALL	VALUE		;fetch input
	JP	NZ,EXIT		;error, abort
;
	LD	(IY+15),C	;save surface count
	RET			;back
;
	PAGE
;
;	binary => ascii
;
ASCII	LD	C,'0'		;start digit
ASC1	SUB	100		;100's place
	JR	C,ASC2		;have digit
	INC	C		;bump ascii
	JR	ASC1
ASC2	ADD	A,100		;adjust back
	LD	(HL),C		;insert char
	INC	HL		;bump pointer
ASCII2	LD	C,'0'		;start again
ASC3	SUB	10		;10's place
	JR	C,ASC4		;have it
	INC	C		;bump ascii
	JR	ASC3
ASC4	LD	(HL),C		;put NSB
	INC	HL
	ADD	A,3AH		;adjust to ascii
	LD	(HL),A		;to the string
	RET			;string loaded
;
VALUE	LD	A,1-1<4+13	;sys1 # 13
	RST	OVLAY		;go direct
;
	PAGE
;
;	display text string
;
DISPLAY	PUSH	HL
;
DISPLP	LD	A,(HL)		;get a byte
	CP	3		;term?
	JR	Z,DISPDN	;yes, go
	CALL	DSPCHR		;display character
	INC	HL		;next byte
	JR	DISPLP		;go more
;
DISPDN	POP	HL		;unstack
	RET			;back to caller
;
DSPCHR	PUSH	BC		;save it
	LD	B,A		;pass char
	LD	A,VDCHAR	;SVC #
	RST	SVC		;display byte
	POP	BC		;unstack
	RET	Z		;no error
	JP	EXIT		;abort program
;
	PAGE
;
;	check for valid filespec character
;
VALCHR	PUSH	HL		;save
	PUSH	BC
	LD	HL,VALTBL	;invalid chars
	LD	BC,18		;length
	CPIR			;is it here?
	POP	BC		;unstack
	POP	HL
	RET			;Z = invalid
;
;
VALTBL	DEFM	'!'
	DEFM	'*'
	DEFM	'?'
	DEFM	'('
	DEFM	')'
	DEFM	','
	DEFM	'.'
	DEFM	'/'
	DEFM	';'
	DEFM	':'
	DEFM	'@'
	DEFM	'='
	DEFM	'"'
	DEFB	27H
	DEFB	3
	DEFB	13
	DEFB	7BH
	DEFB	7DH
;
	PAGE
;
;	text
;
;##
;
DEFNAME	DEFW	MPASSW		;master password
	DEFM	'*DIRFIX*00/00/00'
	DEFB	0DH
;
PMSG	DEFM	'*'		;prompt
SPECKS	DEFB	'#'		;special prompt
;
CANTFX	DEFM	'File(s) Directory Record(s) Corrupt'
	DEFB	13
	DEFM	'Cannot Repair Without "F" Option'
	DEFB	13
	DEFB	3
;
HELLO	DEFB	13
	DEFM	'DIRFIX - '
	DEFM	'DosPLUS II Directory Repair Utility - '
	DEFM	'Series A.00'
	DEFB	13
	DEFM	'(c)(p) Copyright 1982 '
	DEFM	'by MicroPower, Inc.'
	DEFB	13
	DEFB	13
	DEFB	13
	DEFB	3
;
;
FIXBLK	DEFB	0
	DEFW	DCB
	DEFW	DCB
	DEFW	DCB
	DEFW	FIXPARM		;parameter block
;
FIXPARM	DEFB	20H+5
	DEFW	PROPAR
	DEFM	'PROMPT'
;
	DEFB	20H+2
	DEFW	GATPAR
	DEFM	'GAT'
;
	DEFB	20H+2
	DEFW	HITPAR
	DEFM	'HIT'
;
	DEFB	20H+4
	DEFW	FILPAR
	DEFM	'FILES'
;
	DEFB	20H+3
	DEFW	LOCPAR
	DEFM	'LOCK'
;
	DEFB	0
;
PROPAR	DEFW	0		;prompt
GATPAR	DEFW	0		;gat
HITPAR	DEFW	0		;hit
FILPAR	DEFW	0		;files
LOCPAR	DEFW	0		;lockout x track
;
GATBUFF	DEFW	0		;gat pointer
HITBUFF	DEFW	0		;hit pointer
DIRBUF	DEFW	0		;file record pointer
;
DCB	DEFS	41		;file DCB
STRING	DEFS	80		;key input buffer
;
ZZZZZ	EQU	$		;end of program
;
	END	ENTRY
