; help/asm - kjw/bqsd - 08/82
;
	TITLE	'<DosPLUS II A.0 - Help Utility>'
;
SERROR	EQU	39		;display error message
VDCHAR	EQU	8		;char to video
FSPEC	EQU	84		;fetch filespec
VDLINE	EQU	9		;string to video
VDREAD	EQU	11		;read cursor posit
VDGRAF	EQU	10		;put cursor posit
;
UCASE	EQU	031EH		;char to upper case
;
SVC	EQU	08		;execute SVC
;
CR	EQU	13
ETX	EQU	3
LBR	EQU	5BH		;left brace
RBR	EQU	5DH		;right brace
LB	EQU	7BH		;left bracket
RB	EQU	7DH		;right bracket
SWITCH	EQU	90H
VALUE	EQU	0A0H
STRING	EQU	0B0H
;
	ORG	2200H		;high overlay area
;
;	program entry point
;
ENTRY	LD	(STACK),SP	;save the stack
	LD	A,CR		;start with CR
	CALL	DSP$		;display it
;
;	evaluate user input
;
SCAN	CALL	POSHL		;any input?
	JR	Z,SHOWCM	;display all commands
	LD	DE,DCB		;use as DCB
	LD	A,FSPEC		;SVC #
	RST	SVC		;fetch the command word
	JR	NZ,SHOWCM	;invalid, show commands!
;
	CALL	FIND		;find the word
	JR	Z,SHOWCM	;not found!
	CP	39		;1-38?
	JR	C,SHOW		;valid, go!
;
;	display library commands
;
SHOWCM	LD	HL,HELP		;message
	LD	BC,HELPL<8+0	;length + term
	LD	A,VDLINE	;SVC #
	RST	SVC		;display header
;
	LD	BC,2601H	;B=looper, C=word
;
SHOWEM	PUSH	BC		;save 'em
	LD	A,C		;get word #
	LD	(WORNUM),A	;save it
	LD	D,0		;command
	LD	A,VDREAD	;SVC #
	RST	SVC		;fetch cursor
	PUSH	BC		;save cursor
	LD	A,0		;get word #
WORNUM	EQU	$-1
	CALL	WORD		;display it
	POP	BC		;get cursor
	LD	D,0		;command
	LD	A,VDGRAF	;SVC #
	RST	SVC		;put cursor
	LD	A,9		;send single tab
	CALL	DSP$		;display it
	POP	BC		;get word # / counter
	INC	C		;bump word number
	DJNZ	SHOWEM		;finish the list
	JR	DONE		;done, CR and $EXIT
;
	PAGE
;
;	locate command in table
;
FIND	LD	B,0		;position counter
	LD	HL,TABLE1	;word table
	INC	DE		;bump to text
FINLP	INC	B		;bump command #
	LD	A,(HL)		;get table
	INC	HL		;bump position
	OR	A		;check for word start
	JP	P,FINLP+1	;go till start found
	AND	7FH		;check for table term
	RET	Z		;not found!
;
	PUSH	DE		;save string
FINLP1	LD	C,A		;C = char
	LD	A,(DE)		;get user byte
	CALL	UCASE		;make it upper case
	CP	C		;match?
	JR	NZ,HAVCNT	;nope, go next word
	LD	A,(HL)		;fetch next char
	INC	DE		;bump string
	INC	HL		;bump table
	JR	FINLP1		;check next word
;
HAVCNT	POP	DE		;get string start back
	BIT	7,C		;end word entry?
	JR	Z,FINLP		;nope, continue
	CP	ETX		;terminator?
	DEC	HL		;adjust table
	JR	NZ,FINLP	;nope, go!
	LD	A,B		;get table posit
	OR	A		;set NZ for found
	RET			;return with A = command
;
;	$POSHL - position HL to first significant char
;
	INC	HL		;bump pointer
POSHL	LD	A,(HL)		;fetch a character
	CP	' '		;separator?
	JR	Z,POSHL-1	;go if yes
	CP	','		;separator?
	JR	Z,POSHL-1	;yes, go!
;
CKTERM	CP	CR		;CR?
	RET	Z		;yes, return
	CP	';'		;semi (embedded CR)?
	RET	Z		;yes, return
	CP	ETX		;break char?
	RET			;Z = yes
;
	PAGE
;
;	display command syntax
;
SHOW	DEC	A		;adjust to relative 0
	ADD	A,A		;double for table
	LD	C,A		;pass to BC
	LD	B,0		;BC = table offset
	LD	HL,TABLE0	;lookup table
	ADD	HL,BC		;HL => indirect address
	LD	A,(HL)		;get LSB pointer
	INC	HL		;bump pointer
	LD	H,(HL)		;get MSB pointer
	LD	L,A		;HL => syntax table
	PUSH	HL		;pass to IX
	POP	IX		;IX => syntax table
;
SHOW1	LD	A,(IX)		;get command
	INC	IX		;bump pointer
	CP	-1		;terminator?
	JR	Z,DONE		;yes, done!
	CP	-2		;param pointer?
	JR	Z,PARAMS	;yes, go!
	CALL	WORD		;display the word
	JR	SHOW1		;continue!
;
PARAMS	LD	A,CR		;start new line
	CALL	DSP$		;display CR
	LD	A,CR		;blank line
	CALL	DSP$
;
PARAML	LD	A,(IX)		;get command
	INC	IX		;bump pointer
	CP	-1		;terminator?
	JR	Z,DONE		;yes, done!
	CALL	PARAM		;display param
	JR	PARAML		;continue!
;
DONE	LD	A,CR		;send another CR
	CALL	DSP$		;display it
	JR	EXIT		;exit program
;
WORD	LD	HL,TABLE1	;word table
	LD	B,1		;word counter
;
WORD1	BIT	7,(HL)		;word start?
	INC	HL		;bump pointer
	JR	Z,WORD1		;find word start
	CP	B		;correct word?
	JR	Z,WORD2		;yes, go!
	INC	B		;bump word pointer
	JR	WORD1		;continue
;
WORD2	DEC	HL		;dec counter
	JR	WORD4		;continue
;
WORD3	BIT	7,(HL)		;next word start?
	JR	Z,WORD4		;nope, continue
	LD	A,' '		;space between words
	JR	DSP$		;display it!
;
WORD4	LD	A,(HL)		;get the byte
	AND	7FH		;remove high bit
	CALL	DSP$		;display it
	INC	HL		;bump pointer
	JR	WORD3		;continue
;
;	display param word
;
PARAM	LD	HL,TABLE2	;lookup table
	LD	B,1		;position counter
;
PARAM1	BIT	7,(HL)		;start of word?
	INC	HL		;bump pointer
	JR	Z,PARAM1	;find word start
	CP	B		;correct word?
	JR	Z,PARAM2	;yes, go!
	INC	B		;bump position
	JR	PARAM1		;continue
;
PARAM2	LD	D,0		;command
	LD	A,VDREAD	;SVC #
	RST	SVC		;get cursor posit
	PUSH	BC		;save cursor posit
	DEC	HL		;HL => start
	LD	A,(HL)		;get length/type of param
	PUSH	AF		;save type
	INC	HL		;bump pointer
	AND	0FH		;low 4 bits = length
	LD	B,A		;B = length
;
PARAM3	LD	A,(HL)		;get a char
	CALL	DSP$		;display char
	INC	HL		;bump pointer
	DJNZ	PARAM3		;continue
;
	POP	AF		;get type
	RRCA			;align the bits
	RRCA			;654 => 210
	RRCA
	RRCA
	AND	7		;low 3 bits only
	JR	Z,NOTPAR	;nothing else
	ADD	A,58		;offset to type
	CALL	WORD		;display the word
NOTPAR	POP	BC		;restore start video
	LD	D,0		;command
	LD	A,VDGRAF	;SVC #
	RST	SVC		;set cursor
;
;	tab over 16 spaces
;
TAB	LD	A,9		;tab char
	CALL	DSP$		;display it
	LD	A,9		;again
;
;	display char to video
;
DSP$	PUSH	BC		;save it
	LD	B,A		;pass the char
	LD	A,VDCHAR	;SVC #
	RST	SVC		;display char
	POP	BC		;restore stack
	RET	Z		;no error, return
;
POSTE	AND	7FH		;assure a return
	LD	B,A		;pass error #
	LD	A,SERROR	;SVC #
	RST	SVC		;display error
;
EXIT	LD	SP,0		;get stack
STACK	EQU	$-2
	XOR	A		;return ZERO
	RET			;back to caller
;
	PAGE
;
HELP	DEFM	'Help is available for the following:'
	DEFB	CR
	DEFB	CR
HELPL	EQU	$-HELP
;
DCB	DEFS	41		;for filespec use
;
	PAGE
;
;	lookup tables
;
TABLE0	DEFW	APPEND
	DEFW	ATTRIB
	DEFW	AUTO
	DEFW	BOOT
	DEFW	BUILD
	DEFW	CAT
	DEFW	CLEAR
	DEFW	CLOCK
	DEFW	CLS
	DEFW	CONFIG
	DEFW	COPY
	DEFW	CREATE
	DEFW	DATE
	DEFW	DEBUG
	DEFW	DIR
	DEFW	DO
	DEFW	DUMP
	DEFW	ERROR
	DEFW	FILTER
	DEFW	FORMS
	DEFW	FREE
	DEFW	I@
	DEFW	KILL
	DEFW	LIB
	DEFW	LINK
	DEFW	LIST
	DEFW	LOAD
	DEFW	PAUSE
	DEFW	PROT
	DEFW	RENAME
	DEFW	RESET
	DEFW	ROUTE
	DEFW	SCREEN
	DEFW	SET
	DEFW	SETCOM
	DEFW	SYSTEM
	DEFW	TIME
	DEFW	VERIFY
;
;	table of words
;
TABLE1	DEFB	'A'+80H		;1 - append
	DEFM	'PPEND'
	DEFB	'A'+80H		;2 - attrib
	DEFM	'TTRIB'
	DEFB	'A'+80H		;3 - auto
	DEFM	'UTO'
	DEFB	'B'+80H		;4 - boot
	DEFM	'OOT'
	DEFB	'B'+80H		;5 - build
	DEFM	'UILD'
	DEFB	'C'+80H		;6 - cat
	DEFM	'AT'
	DEFB	'C'+80H		;7 - clear
	DEFM	'LEAR'
	DEFB	'C'+80H		;8 - clock
	DEFM	'LOCK'
	DEFB	'C'+80H		;9 - cls
	DEFM	'LS'
	DEFB	'C'+80H		;10 - config
	DEFM	'ONFIG'
	DEFB	'C'+80H		;11 - copy
	DEFM	'OPY'
	DEFB	'C'+80H		;12 - create
	DEFM	'REATE'
	DEFB	'D'+80H		;13 - date
	DEFM	'ATE'
	DEFB	'D'+80H		;14 - debug
	DEFM	'EBUG'
	DEFB	'D'+80H		;15 - dir
	DEFM	'IR'
	DEFB	'D'+80H		;16 - do
	DEFM	'O'
	DEFB	'D'+80H		;17 - dump
	DEFM	'UMP'
	DEFB	'E'+80H		;18 - error
	DEFM	'RROR'
	DEFB	'F'+80H		;19 - filter
	DEFM	'ILTER'
	DEFB	'F'+80H		;20 - forms
	DEFM	'ORMS'
	DEFB	'F'+80H		;21 - free
	DEFM	'REE'
	DEFB	'I'+80H		;22 - i
	DEFB	'K'+80H		;23 - kill
	DEFM	'ILL'
	DEFB	'L'+80H		;24 - lib
	DEFM	'IB'
	DEFB	'L'+80H		;25 - link
	DEFM	'INK'
	DEFB	'L'+80H		;26 - list
	DEFM	'IST'
	DEFB	'L'+80H		;27 - load
	DEFM	'OAD'
	DEFB	'P'+80H		;28 - pause
	DEFM	'AUSE'
	DEFB	'P'+80H		;29 - prot
	DEFM	'ROT'
	DEFB	'R'+80H		;30 - rename
	DEFM	'ENAME'
	DEFB	'R'+80H		;31 - reset
	DEFM	'ESET'
	DEFB	'R'+80H		;32 - route
	DEFM	'OUTE'
	DEFB	'S'+80H		;33 - screen
	DEFM	'CREEN'
	DEFB	'S'+80H		;34 - set
	DEFM	'ET'
	DEFB	'S'+80H		;35 - setcom
	DEFM	'ETCOM'
	DEFB	'S'+80H		;36 - system
	DEFM	'YSTEM'
	DEFB	'T'+80H		;37 - time
	DEFM	'IME'
	DEFB	'V'+80H		;38 - verify
	DEFM	'ERIFY'
	DEFB	LBR+80H		;39 - (FROM)
	DEFM	'FROM'
	DEFB	RBR
	DEFB	LBR+80H		;40 - (TO)
	DEFM	'TO'
	DEFB	RBR
	DEFB	LBR+80H		;41 - (USING)
	DEFM	'USING'
	DEFB	RBR
	DEFB	LB+80H		;42 - <param>
	DEFM	'param=exp'
	DEFB	RB
	DEFB	LB+80H		;43 - <param=exp, ...>
	DEFM	'param=exp, ...'
	DEFB	RB
	DEFB	'c'+80H		;44 - channel
	DEFM	'hannel'
	DEFB	'w'+80H		;45 - wildmask
	DEFM	'ildmask'
	DEFB	'd'+80H		;46 - drivespec
	DEFM	'rivespec'
	DEFB	'd'+80H		;47 - devicespec
	DEFM	'evicespec'
	DEFB	'f'+80H		;48 - filespec
	DEFM	'ilespec'
	DEFB	LBR+80H		;49 - (drivespec)
	DEFM	'drivespec'
	DEFB	RBR
	DEFB	LBR+80H		;50 - (!#command)
	DEFM	'!#command'
	DEFB	RBR
	DEFB	LBR+80H		;51 - (filespec)
	DEFM	'filespec'
	DEFB	RBR
	DEFB	LBR+80H		;52 - (switch)
	DEFM	'switch'
	DEFB	RBR
	DEFB	LBR+80H		;53 - (date)
	DEFM	'date'
	DEFB	RBR
	DEFB	LBR+80H		;54 - (value)
	DEFM	'value'
	DEFB	RBR
	DEFB	LBR+80H		;55 - (channel)
	DEFM	'channel'
	DEFB	RBR
	DEFB	LBR+80H		;56 - (devicespec)
	DEFM	'devicespec'
	DEFB	RBR
	DEFB	LBR+80H		;57 - (message)
	DEFM	'message'
	DEFB	RBR
	DEFB	LBR+80H		;58 - (time)
	DEFM	'time'
	DEFB	RBR
	DEFB	'='+80H		;59 - =switch
	DEFM	'switch'
	DEFB	'='+80H		;60 - =value
	DEFM	'value'
	DEFB	'='+80H		;61 - string
	DEFM	'string'
	DEFB	CR+80H		;62 - CR
	DEFB	8
	DEFB	LB+80H		;63 - <switch>
	DEFM	'switch'
	DEFB	RB
;
	DEFB	80H		;terminator
;
	PAGE
;
;	parameter table
;
TABLE2	DEFB	SWITCH+6	;1
	DEFM	'(K)ILL'
	DEFB	SWITCH+5	;2
	DEFM	'(C)MD'
	DEFB	SWITCH+7	;3
	DEFM	'(S)TRIP'
	DEFB	STRING+5	;4
	DEFM	'(A)CC'
	DEFB	SWITCH+5	;5
	DEFM	'(I)NV'
	DEFB	SWITCH+6	;6
	DEFM	'(K)EEP'
	DEFB	SWITCH+5	;7
	DEFM	'(M)OD'
	DEFB	VALUE+6		;8
	DEFM	'(P)ROT'
	DEFB	STRING+2	;9
	DEFM	'PW'
	DEFB	STRING+5	;10
	DEFM	'(U)PD'
	DEFB	SWITCH+8	;11
	DEFM	'(A)PPEND'
	DEFB	SWITCH+7	;12
	DEFM	'(A)LPHA'
	DEFB	SWITCH+6	;13
	DEFM	'(K)ILL'
	DEFB	SWITCH+5	;14
	DEFM	'(S)YS'
	DEFB	VALUE+7		;15
	DEFM	'(S)TART'
	DEFB	VALUE+5		;16
	DEFM	'(E)ND'
	DEFB	VALUE+6		;17
	DEFM	'(D)ATA'
	DEFB	SWITCH+4	;18
	DEFM	'(H)L'
	DEFB	SWITCH+4	;19
	DEFM	'(M)D'
	DEFB	VALUE+4		;20
	DEFM	'(P)D'
	DEFB	VALUE+4		;21
	DEFM	'SIZE'
	DEFB	SWITCH+4	;22
	DEFM	'SKIP'
	DEFB	VALUE+6		;23
	DEFM	'(S)TEP'
	DEFB	SWITCH+4	;24
	DEFM	'(W)P'
	DEFB	VALUE+4		;25
	DEFM	'(C)O'
	DEFB	SWITCH+5	;26
	DEFM	'FIXED'
	DEFB	VALUE+4		;27
	DEFM	'(H)O'
	DEFB	VALUE+4		;28
	DEFM	'(T)S'
	DEFB	STRING+5	;29
	DEFM	'(D)PW'
	DEFB	SWITCH+6	;30
	DEFM	'(E)CHO'
	DEFB	SWITCH+5	;31
	DEFM	'MOUNT'
	DEFB	SWITCH+6	;32
	DEFM	'(O)VER'
	DEFB	SWITCH+7	;33
	DEFM	'(Q)UERY'
	DEFB	STRING+3	;34
	DEFM	'SPW'
	DEFB	SWITCH+6	;35
	DEFM	'(T)INY'
	DEFB	VALUE+7		;36
	DEFM	'(G)RANS'
	DEFB	VALUE+4		;37
	DEFM	'KILO'
	DEFB	VALUE+5		;38
	DEFM	'(L)RL'
	DEFB	VALUE+6		;39
	DEFM	'(S)IZE'
	DEFB	SWITCH+8	;40
	DEFM	'(V)ERIFY'
	DEFB	SWITCH+7	;41
	DEFM	'(B)REAK'
	DEFB	VALUE+6		;42
	DEFM	'(R)ELO'
	DEFB	VALUE+5		;43
	DEFM	'(T)RA'
	DEFB	VALUE+4		;44
	DEFM	'(B)S'
	DEFB	VALUE+6		;45
	DEFM	'(C)ODE'
	DEFB	SWITCH+7	;46
	DEFM	'(E)MPTY'
	DEFB	VALUE+7		;47
	DEFM	'(L)INES'
	DEFB	VALUE+6		;48
	DEFM	'(P)AGE'
	DEFB	SWITCH+7	;49
	DEFM	'(R)ESET'
	DEFB	SWITCH+8	;50
	DEFM	'(S)ERIAL'
	DEFB	SWITCH+5	;51
	DEFM	'(T)OP'
	DEFB	SWITCH+7	;52
	DEFM	'(U)CASE'
	DEFB	VALUE+7		;53
	DEFM	'(W)IDTH'
	DEFB	SWITCH+7	;54
	DEFM	'(X)LATE'
	DEFB	SWITCH+7	;55
	DEFM	'(M)OUNT'
	DEFB	STRING+4	;56
	DEFM	'(P)W'
	DEFB	SWITCH+5	;57
	DEFM	'(C)TL'
	DEFB	SWITCH+8	;58
	DEFM	'(P)ROMPT'
	DEFB	SWITCH+5	;59
	DEFM	'(R)UN'
	DEFB	SWITCH+5	;60
	DEFM	'(A)CC'
	DEFB	SWITCH+7	;61
	DEFM	'(C)LEAN'
	DEFB	STRING+6	;62
	DEFM	'(D)ATE'
	DEFB	SWITCH+6	;63
	DEFM	'(L)OCK'
	DEFB	STRING+5	;64
	DEFM	'(M)PW'
	DEFB	STRING+6	;65
	DEFM	'(N)AME'
	DEFB	SWITCH+5	;66
	DEFM	'(U)PD'
	DEFB	VALUE+6		;67
	DEFM	'(B)AUD'
	DEFB	VALUE+2		;68
	DEFM	'BS'
	DEFB	STRING+8	;69
	DEFM	'(P)ARITY'
	DEFB	VALUE+6		;70
	DEFM	'(S)TOP'
	DEFB	VALUE+6		;71
	DEFM	'(W)ORD'
	DEFB	SWITCH+7	;72
	DEFM	'(A)LIVE'
	DEFB	SWITCH+7	;73
	DEFM	'(B)REAK'
	DEFB	SWITCH+6	;74
	DEFM	'(D)ATE'
	DEFB	VALUE+7		;75
	DEFM	'(H)IMEM'
	DEFB	SWITCH+4	;76
	DEFM	'LOGO'
	DEFB	VALUE+7		;77
	DEFM	'(L)OMEM'
	DEFB	STRING+6	;78
	DEFM	'(S)AVE'
	DEFB	SWITCH+6	;79
	DEFM	'(T)IME'
	DEFB	SWITCH+5	;80
	DEFM	'TRACE'
	DEFB	SWITCH+8	;81
	DEFM	'(F)LOPPY'
	DEFB	SWITCH+7	;82
	DEFM	'(R)IGID'
	DEFB	80H+1		;83
	DEFM	' '
	DEFB	SWITCH+2	;84
	DEFM	'LF'
;
	DEFB	80H
;
	PAGE
;
;	lookup table for display listing
;
APPEND	DEFB	1
	DEFB	39
	DEFB	44
	DEFB	40
	DEFB	44
	DEFB	43
	DEFB	-2
	DEFB	1
	DEFB	2
	DEFB	3
	DEFB	-1
;
ATTRIB	DEFB	2
	DEFB	45
	DEFB	43
	DEFB	-2
	DEFB	4
	DEFB	5
	DEFB	6
	DEFB	7
	DEFB	8
	DEFB	9
	DEFB	10
	DEFB	-1
;
AUTO	DEFB	3
	DEFB	49
	DEFB	50
	DEFB	-1
;
BOOT	DEFB	4
	DEFB	-1
;
BUILD	DEFB	5
	DEFB	48
	DEFB	42
	DEFB	-2
	DEFB	11
	DEFB	-1
;
CAT	DEFB	6
	DEFB	39
	DEFB	46
	DEFB	40
	DEFB	44
	DEFB	41
	DEFB	45
	DEFB	43
	DEFB	-2
	DEFB	12
	DEFB	5
	DEFB	13
	DEFB	14
	DEFB	-1
;
CLEAR	DEFB	7
	DEFB	51
	DEFB	43
	DEFB	-2
	DEFB	15
	DEFB	16
	DEFB	17
	DEFB	-1
;
CLOCK	DEFB	8
	DEFB	52
	DEFB	-1
;
CLS	DEFB	9
	DEFB	-1
;
CONFIG	DEFB	10
	DEFB	49
	DEFB	43
	DEFB	-2
	DEFB	81
	DEFB	18
	DEFB	19
	DEFB	20
	DEFB	21
	DEFB	22
	DEFB	23
	DEFB	24
	DEFB	83
	DEFB	83
	DEFB	82
	DEFB	25
	DEFB	26
	DEFB	27
	DEFB	21
	DEFB	20
	DEFB	23
	DEFB	28
	DEFB	24
	DEFB	-1
;
COPY	DEFB	11
	DEFB	39
	DEFB	44
	DEFB	40
	DEFB	44
	DEFB	62
	DEFB	11
	DEFB	39
	DEFB	48
	DEFB	40
	DEFB	48
	DEFB	43
	DEFB	62
	DEFB	11
	DEFB	39
	DEFB	48
	DEFB	40
	DEFB	46
	DEFB	43
	DEFB	62
	DEFB	11
	DEFB	39
	DEFB	46
	DEFB	40
	DEFB	46
	DEFB	41
	DEFB	45
	DEFB	43
	DEFB	-2
	DEFB	29
	DEFB	30
	DEFB	5
	DEFB	13
	DEFB	7
	DEFB	31
	DEFB	32
	DEFB	33
	DEFB	34
	DEFB	35
	DEFB	-1
;
CREATE	DEFB	12
	DEFB	48
	DEFB	43
	DEFB	-2
	DEFB	17
	DEFB	36
	DEFB	6
	DEFB	37
	DEFB	38
	DEFB	39
	DEFB	40
	DEFB	-1
;
DATE	DEFB	13
	DEFB	53
	DEFB	-1
;
DEBUG	DEFB	14
	DEFB	52
	DEFB	-1
;
DIR	DEFB	15
	DEFB	39
	DEFB	46
	DEFB	40
	DEFB	44
	DEFB	41
	DEFB	45
	DEFB	43
	DEFB	-2
	DEFB	12
	DEFB	5
	DEFB	13
	DEFB	14
	DEFB	-1
;
DO	DEFB	16
	DEFB	48
	DEFB	42
	DEFB	-2
	DEFB	41
	DEFB	-1
;
DUMP	DEFB	17
	DEFB	48
	DEFB	43
	DEFB	-2
	DEFB	17
	DEFB	16
	DEFB	42
	DEFB	15
	DEFB	43
	DEFB	-1
;
ERROR	DEFB	18
	DEFB	54
	DEFB	-1
;
FILTER	DEFB	19
	DEFB	39
	DEFB	47
	DEFB	40
	DEFB	48
	DEFB	63
	DEFB	-1
;
FORMS	DEFB	20
	DEFB	43
	DEFB	-2
	DEFB	44
	DEFB	45
	DEFB	46
	DEFB	47
	DEFB	84
	DEFB	48
	DEFB	49
	DEFB	50
	DEFB	51
	DEFB	52
	DEFB	53
	DEFB	54
	DEFB	-1
;
FREE	DEFB	21
	DEFB	39
	DEFB	49
	DEFB	40
	DEFB	55
	DEFB	-1
;
I@	DEFB	22
	DEFB	49
	DEFB	42
	DEFB	-2
	DEFB	55
	DEFB	-1
;
KILL	DEFB	23
	DEFB	48
	DEFB	43
	DEFB	62
	DEFB	23
	DEFB	39
	DEFB	49
	DEFB	41
	DEFB	45
	DEFB	43
	DEFB	62
	DEFB	23
	DEFB	46
	DEFB	62
	DEFB	23
	DEFB	47
	DEFB	-2
	DEFB	30
	DEFB	5
	DEFB	56
	DEFB	33
	DEFB	14
	DEFB	-1
;
LIB	DEFB	24
	DEFB	40
	DEFB	55
	DEFB	-1
;
LINK	DEFB	25
	DEFB	39
	DEFB	56
	DEFB	40
	DEFB	55
	DEFB	-1
;
LIST	DEFB	26
	DEFB	39
	DEFB	44
	DEFB	40
	DEFB	55
	DEFB	42
	DEFB	-2
	DEFB	57
	DEFB	-1
;
LOAD	DEFB	27
	DEFB	48
	DEFB	43
	DEFB	-2
	DEFB	58
	DEFB	59
	DEFB	15
	DEFB	43
	DEFB	-1
;
PAUSE	DEFB	28
	DEFB	57
	DEFB	-1
;
PROT	DEFB	29
	DEFB	49
	DEFB	43
	DEFB	-2
	DEFB	60
	DEFB	61
	DEFB	62
	DEFB	63
	DEFB	64
	DEFB	65
	DEFB	56
	DEFB	66
	DEFB	-1
;
RENAME	DEFB	30
	DEFB	39
	DEFB	48
	DEFB	40
	DEFB	48
	DEFB	62
	DEFB	30
	DEFB	46
	DEFB	46
	DEFB	62
	DEFB	30
	DEFB	47
	DEFB	47
	DEFB	-1
;
RESET	DEFB	31
	DEFB	56
	DEFB	-1
;
ROUTE	DEFB	32
	DEFB	39
	DEFB	56
	DEFB	40
	DEFB	55
	DEFB	-1
;
SCREEN	DEFB	33
	DEFB	40
	DEFB	55
	DEFB	-1
;
SET	DEFB	34
	DEFB	39
	DEFB	47
	DEFB	40
	DEFB	48
	DEFB	62
	DEFB	34
	DEFB	39
	DEFB	46
	DEFB	40
	DEFB	46
	DEFB	62
	DEFB	34
	DEFB	39
	DEFB	47
	DEFB	40
	DEFB	47
	DEFB	-1
;
SETCOM	DEFB	35
	DEFB	56
	DEFB	43
	DEFB	-2
	DEFB	67
	DEFB	68
	DEFB	46
	DEFB	69
	DEFB	70
	DEFB	71
	DEFB	-1
;
SYSTEM	DEFB	36
	DEFB	43
	DEFB	-2
	DEFB	72
	DEFB	73
	DEFB	74
	DEFB	75
	DEFB	76
	DEFB	77
	DEFB	78
	DEFB	79
	DEFB	80
	DEFB	-1
;
TIME	DEFB	37
	DEFB	58
	DEFB	-1
;
VERIFY	DEFB	38
	DEFB	52
	DEFB	-1
;
ZZZZZ	EQU	$
;
	END	ENTRY
