; svcint/asm - kjw/bqsd - 08/82
;
	TITLE	'<DosPLUS II.A - SVC interceptor>'
;
	ORG	2200H		;load into high overlay
;
FETMEM	EQU	0330H		;fetch top memory
;
VDLINE	EQU	9		;string to video
ERROR	EQU	39		;display error message
SETUSR	EQU	2		;setup user SVC
;
SVC	EQU	08H		;execute SVC
;
CR	EQU	13
;
;	display title banner
;
ENTRY	LD	HL,HELLO	;title message
	LD	BC,HELLOL<8+0	;length + term
	LD	A,VDLINE	;SVC #
	RST	SVC		;display it
;
;	check for sufficient memory
;
	LD	BC,CODEL	;length of new code
	CALL	FETMEM		;fetch memory
	JR	Z,READY		;enough, go!
;
POSTE	LD	B,A		;pass error
	LD	A,ERROR		;SVC #
	RST	SVC		;display error
	XOR	A		;return zero
	RET			;return to caller
;
;	HL => relocation address
;	BC =  length of code
;
READY	LD	(NEWADD),HL	;save new address
	LD	DE,CODE		;get current address
	OR	A		;clear carry flag
	SBC	HL,DE		;HL = offset
	LD	(OFFSET),HL	;save it
;
;	install new SVC's from table
;
INSTALL	LD	IX,TABLE	;table of entries
;
INSTLP	LD	A,(IX)		;get SVC #
	OR	A		;table terminator?
	JR	Z,RELOCAT	;relocate the code
;
;	fetch old vector
;
	LD	B,A		;pass SVC #
	LD	C,0		;set REMOVE
	LD	A,SETUSR	;SVC #
	RST	SVC		;fetch the old entry
;
;	place vector into code
;
	EX	DE,HL		;DE = old vector
	LD	L,(IX+1)	;LSB vector save
	LD	H,(IX+2)	;MSB vector save
	LD	(HL),E		;insert old vector
	INC	HL		;bump pointer
	LD	(HL),D		;old vector MSB
;
;	fetch new vector for SVC
;
	LD	L,(IX+3)	;get new vector
	LD	H,(IX+4)	;new MSB
	LD	DE,0		;get offset to new locate
OFFSET	EQU	$-2
	ADD	HL,DE		;HL => new address
	DEC	C		;C = ADD
	LD	A,SETUSR	;SVC #
	RST	SVC		;add new vector in!
;
;	point to next entry
;
	LD	DE,5		;table entry length
	ADD	IX,DE		;IX => next entry
	JR	INSTLP		;install next vector
;
;	relocate code to new position
;
RELOCAT	LD	HL,CODE		;current address
	LD	DE,0		;get new address
NEWADD	EQU	$-2
	LD	BC,CODEL	;length of code
	LDIR			;move it there!
;
	XOR	A		;return to caller zero
	RET			;done! all installed
;
;	table for resolving relocation parameters
;
;	each entry is 5 bytes long
;	+0	- SVC # to change (00 = table terminator)
;	+1,+2	- address to place OLD svc address
;	+3,+4	- address of NEW svc code
;
TABLE	DEFB	37		;$DOSCMD
	DEFW	DOSCMD$		;old vector
	DEFW	DOSCMD		;new vector
;
	DEFB	38		;$RETCMD
	DEFW	RETCMD$
	DEFW	RETCMD
;
	DEFB	3		;$SETBRK
	DEFW	SETBRK$
	DEFW	SETBRK
;
	DEFB	0		;terminator
;
;	title banner
;
HELLO	DEFB	CR
	DEFM	'SVCINT - '
	DEFM	'DosPLUS II Supervisor Interceptor - '
	DEFM	'Series A.00'
	DEFB	CR
	DEFM	'(c)(p) Copyright 1982 '
	DEFM	'by MicroPower, Inc.'
	DEFB	CR
	DEFB	CR
	DEFB	CR
HELLOL	EQU	$-HELLO
;
;	actual code to relocate to TOPMEM
;
CODE	EQU	$		;intercept code begins
;
;	intercept for $DOSCMD
;
DOSCMD	PUSH	HL		;save string pointer
	LD	HL,0		;get old vector
DOSCMD$	EQU	$-2
	JR	NEWCMD		;go common
;
;	intercept for $RETCMD
;
RETCMD	PUSH	HL		;save pointer
	LD	HL,0		;get old vector
RETCMD$	EQU	$-2
;
NEWCMD	EX	(SP),HL		;leave vector, get pntr
	PUSH	HL		;save string start
	PUSH	BC		;save it
	LD	C,B		;pass length
	LD	B,0		;BC = length of command
	ADD	HL,BC		;HL => end +1
	LD	(HL),0DH	;insert terminator
	POP	BC		;restore original
	POP	HL		;get start back
	RET			;go old vector!
;
;	intercept for $SETBRK
;
SETBRK	CALL	0		;call OLD vector
SETBRK$	EQU	$-2
	XOR	A		;but ALWAYS return Z
	RET			;done
;
CODEL	EQU	$-CODE		;length of the code
;
	END	ENTRY		;program entry point
